## 2025-10-27-a.tar.xz

=== src/app/morph-browser/po/CMakeLists.txt ===
project(webbrowser-translations)

include(FindGettext)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

file(RELATIVE_PATH DESKTOP_FILE_IN_IN ${CMAKE_SOURCE_DIR}
    ${morph-browser_SOURCE_DIR}/${DESKTOP_FILE}.in.in)
file(RELATIVE_PATH DESKTOP_FILE_IN_IN_H ${CMAKE_SOURCE_DIR}
     ${CMAKE_CURRENT_SOURCE_DIR}/${DESKTOP_FILE_IN_IN}.h)

file(GLOB_RECURSE I18N_SRC_FILES
     RELATIVE ${CMAKE_SOURCE_DIR}
     ${CMAKE_SOURCE_DIR}/src/app/**.qml)
list(SORT I18N_SRC_FILES)

set(DOMAIN ${GETTEXT_PACKAGE})
set(POT_FILE ${DOMAIN}.pot)
file(GLOB PO_FILES *.po)

add_custom_target(${POT_FILE} ALL
                  COMMENT "Generating translation template"
                  COMMAND ${INTLTOOL_EXTRACT} --update --type=gettext/ini
                          --srcdir=${CMAKE_SOURCE_DIR} ${DESKTOP_FILE_IN_IN}
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --c++ --qt --add-comments=TRANSLATORS
                          --keyword=tr --keyword=tr:1,2 --keyword=N_
                          --package-name=morph-browser
                          --copyright-holder='UBports'
                          -D ${CMAKE_SOURCE_DIR} ${I18N_SRC_FILES}
                          -D ${CMAKE_BINARY_DIR} ${DESKTOP_FILE_IN_IN_H})

foreach(PO_FILE ${PO_FILES})
    get_filename_component(LANG ${PO_FILE} NAME_WE)
    gettext_process_po_files(${LANG} ALL PO_FILES ${PO_FILE})
    set(INSTALL_DIR ${CMAKE_INSTALL_LOCALEDIR}/${LANG}/LC_MESSAGES)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.gmo
            DESTINATION ${INSTALL_DIR}
            RENAME ${DOMAIN}.mo)
endforeach(PO_FILE)

=== src/app/morph-browser/src/Morph/CMakeLists.txt ===
set(QT_INSTALL_QML "/usr/local/lib/${CMAKE_LIBRARY_ARCHITECTURE}/qt5/qml")

execute_process(COMMAND lsb_release --short --release
    OUTPUT_VARIABLE UBUNTU_VERSION OUTPUT_STRIP_TRAILING_WHITESPACE)
add_definitions(-DUBUNTU_VERSION="${UBUNTU_VERSION}")

add_subdirectory(Web)

=== src/app/morph-browser/src/app/CMakeLists.txt ===
project(webbrowser-common)

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5WebEngine REQUIRED)

include(FindPkgConfig)
#pkg_check_modules(LIBAPPARMOR libapparmor REQUIRED)

configure_file(
    config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
    @ONLY)

set(COMMONLIB webbrowser-common)

set(COMMONLIB_SRC
    browserapplication.cpp
    browser-utils.cpp
    domain-permissions-model.cpp
    domain-settings-model.cpp
    domain-settings-sorted-model.cpp
    domain-settings-user-agents-model.cpp
    downloads-model.cpp
    favicon-fetcher.cpp
    file-operations.cpp
    input-method-handler.cpp
    meminfo.cpp
    mime-database.cpp
    session-storage.cpp
    single-instance-manager.cpp
)

add_library(${COMMONLIB} STATIC ${COMMONLIB_SRC})

include_directories(${LIBAPPARMOR_INCLUDE_DIRS})
target_link_libraries(${COMMONLIB}
    Qt5::Core
    Qt5::Gui
    Qt5::Network
    Qt5::Qml
    Qt5::Quick
    Qt5::Widgets
    Qt5::WebEngine
    Qt5::WebEngineCore
    ${LIBAPPARMOR_LDFLAGS}
)

file(GLOB QML_FILES *.qml qmldir)
install(FILES ${QML_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser)
file(GLOB JS_FILES *.js)
install(FILES ${JS_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser)
install(DIRECTORY actions DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser
        FILES_MATCHING PATTERN *.qml)

add_subdirectory(webbrowser)
add_subdirectory(webcontainer)

=== src/app/morph-browser/src/Ubuntu/Web/CMakeLists.txt ===
project(ubuntu-web-plugin)

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Qml REQUIRED)

set(UBUNTU_WEB_IMPORTS_DIR "${QT_INSTALL_QML}/Ubuntu/Web")

set(PLUGIN ubuntu-web-plugin)

set(PLUGIN_SRC plugin.cpp)

add_library(${PLUGIN} MODULE ${PLUGIN_SRC})
target_link_libraries(${PLUGIN}
    Qt5::Core
    Qt5::Gui
    Qt5::Qml
)

file(GLOB UA_OVERRIDES_IN RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ua-overrides-*.js.in)
foreach(_file ${UA_OVERRIDES_IN})
  string(REGEX REPLACE "\\.in$" "" OUTFILE ${_file})
  configure_file(${_file} ${CMAKE_CURRENT_BINARY_DIR}/${OUTFILE} @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${OUTFILE}
          DESTINATION ${UBUNTU_WEB_IMPORTS_DIR})
endforeach(_file)

file(GLOB PLUGIN_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.qml qmldir *.js *.png)
install(TARGETS ${PLUGIN} DESTINATION ${UBUNTU_WEB_IMPORTS_DIR})
install(FILES ${PLUGIN_FILES} DESTINATION ${UBUNTU_WEB_IMPORTS_DIR})

#if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
#  # copy qml files over to build dir to be able to import them uninstalled
#  foreach(_file ${PLUGIN_FILES})
#    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_file}
#                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_file}
#                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${_file} ${CMAKE_CURRENT_BINARY_DIR}/${_file})
#  endforeach(_file)
#  add_custom_target(copy_files_to_build_dir DEPENDS ${PLUGIN_FILES})
#  add_dependencies(${PLUGIN} copy_files_to_build_dir)
#endif()

=== src/app/morph-browser/src/app/webbrowser/CMakeLists.txt ===
project(morph-browser)

#find_package(Qt5Concurrent REQUIRED)
find_package(Qt5Sql REQUIRED)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${webbrowser-common_SOURCE_DIR}
    ${webbrowser-common_BINARY_DIR}
)

set(WEBBROWSER_APP_MODELS_SRC
    bookmarks-model.cpp
    bookmarks-folder-model.cpp
    bookmarks-folderlist-model.cpp
    history-domain-model.cpp
    history-domainlist-model.cpp
    history-lastvisitdatelist-model.cpp
    history-model.cpp
    limit-proxy-model.cpp
    tabs-model.cpp
    text-search-filter-model.cpp
)

set(WEBBROWSER_APP_MODELS morph-browser-models)

add_library(${WEBBROWSER_APP_MODELS} STATIC ${WEBBROWSER_APP_MODELS_SRC})
target_link_libraries(${WEBBROWSER_APP_MODELS}
    Qt5::Core
    Qt5::Sql
#    Qt5::WebEngine
)

set(WEBBROWSER_APP_SRC
    reparenter.cpp
    searchengine.cpp
    morph-browser.cpp
)

set(WEBBROWSER_APP morph-browser)

add_executable(${WEBBROWSER_APP} ${WEBBROWSER_APP_SRC})
target_link_libraries(${WEBBROWSER_APP}
    Qt5::Core
    Qt5::Qml
    Qt5::Quick
    ${COMMONLIB}
    ${WEBBROWSER_APP_MODELS}
)

install(TARGETS ${WEBBROWSER_APP}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

file(GLOB QML_FILES *.qml qmldir *.js)
install(FILES ${QML_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webbrowser)

install(DIRECTORY assets
        DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webbrowser
        FILES_MATCHING PATTERN *.png PATTERN *.svg PATTERN *.sci)

install(DIRECTORY searchengines
        DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webbrowser
        FILES_MATCHING PATTERN *.xml)

configure_file(${DESKTOP_FILE}.in.in ${DESKTOP_FILE}.in @ONLY)
add_custom_target(${DESKTOP_FILE} ALL
                  COMMENT "Merging translations into ${DESKTOP_FILE}"
                  COMMAND ${INTLTOOL_MERGE} -d -u ${CMAKE_SOURCE_DIR}/po
                          ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in ${DESKTOP_FILE})

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

install(FILES "morph-browser.url-dispatcher"
        DESTINATION ${CMAKE_INSTALL_DATADIR}/url-dispatcher/urls)

install(FILES "morph-browser-content-hub.json"
    DESTINATION ${CMAKE_INSTALL_DATADIR}/content-hub/peers
    RENAME morph-browser
    )

if(${CLICK_MODE})
  message("-- Configuring manifest.json")

  execute_process(
    COMMAND dpkg-architecture -qDEB_HOST_ARCH
    OUTPUT_VARIABLE CLICK_ARCH
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  configure_file(manifest.json.in ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json DESTINATION ${CMAKE_INSTALL_PREFIX})
  install(FILES morph-browser.apparmor DESTINATION ${CMAKE_INSTALL_PREFIX})
endif()

=== src/app/morph-browser/src/app/webcontainer/CMakeLists.txt ===
project(webapp-container)

#find_package(Qt5DBus REQUIRED)
find_package(Qt5Sql REQUIRED)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${webbrowser-common_SOURCE_DIR}
    ${webbrowser-common_BINARY_DIR}
)

set(WEBAPP_CONTAINER webapp-container)

set(WEBAPP_CONTAINER_SRC
    chrome-cookie-store.cpp
    cookie-store.cpp
    oxide-cookie-helper.cpp
    local-cookie-store.cpp
    webapp-container.cpp
    webapp-container-helper.cpp
    session-utils.cpp
    url-pattern-utils.cpp
    scheme-filter.cpp
    intent-parser.cpp
)

add_executable(${WEBAPP_CONTAINER} ${WEBAPP_CONTAINER_SRC})

target_link_libraries(${WEBAPP_CONTAINER}
    Qt5::Core
    Qt5::Gui
    Qt5::Qml
    Qt5::Quick
    Qt5::Sql
    ${COMMONLIB}
)

install(TARGETS ${WEBAPP_CONTAINER}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

file(GLOB QML_FILES *.qml *.js)
install(FILES ${QML_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webcontainer)
install(DIRECTORY actions DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webcontainer
        FILES_MATCHING PATTERN *.qml)

install(DIRECTORY assets
        DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webcontainer
        FILES_MATCHING PATTERN *.png)

=== src/app/morph-browser/debian/control ===
Source: morph-browser
Section: x11
Priority: optional
Maintainer: UBports developers
Build-Depends: apparmor:native,
               apparmor-easyprof,
               cmake (>= 2.8.9),
               debhelper (>= 9),
               dh-apparmor,
               dh-translations,
               libapparmor-dev,
               libqt5sql5-sqlite,
               apparmor-easyprof-ubuntu,
               lsb-release,
               pkg-config,
               python3-all:any,
               python3-flake8 (>= 2.2.2-1ubuntu4) | python3-flake8:native,
               qml-module-qt-labs-folderlistmodel,
               qml-module-qt-labs-settings,
               qml-module-qtquick2 (>= 5.4),
               qml-module-qtquick-controls2,
               qml-module-qtquick-layouts,
               qml-module-qtsysteminfo,
               qml-module-qttest,
               qml-module-qtwebengine,
               qt5-default,
               qtbase5-dev (>= 5.4),
               qtbase5-dev-tools,
               qtdeclarative5-dev,
               qtdeclarative5-ubuntu-ui-extras0.2,
               qtdeclarative5-ubuntu-ui-toolkit-plugin (>= 1.3) | qtdeclarative5-ubuntu-ui-toolkit-plugin-gles (>= 1.3),
               qttools5-dev-tools,
               qtwebengine5-dev,
               xvfb,
Standards-Version: 3.9.7
Homepage: https://github.com/ubports/morph-browser
XS-Testsuite: autopkgtest

Package: morph-browser
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         fonts-liberation,
         libqt5sql5-sqlite,
         libqt5webengine5,
         qml-module-qt-labs-folderlistmodel,
         qml-module-qt-labs-settings,
         qml-module-qtquick2 (>= 5.5),
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2 (>= 5.3),
         qml-module-qtsysteminfo,
         qml-module-morph-web (= ${binary:Version}),
         qtdeclarative5-ubuntu-content1,
         qtdeclarative5-ubuntu-ui-extras0.2,
         qtdeclarative5-ubuntu-ui-toolkit-plugin (>= 1.3) | qtdeclarative5-ubuntu-ui-toolkit-plugin-gles (>= 1.3),
         qtdeclarative5-unity-action-plugin,
Replaces: morph-browser-assets,
          qtdeclarative5-ubuntu-ui-extras-browser-plugin (<< 0.22),
Conflicts: morph-browser-assets, webbrowser-app
Provides: morph-browser-assets, webbrowser-app
Breaks: qtdeclarative5-ubuntu-ui-extras-browser-plugin (<< 0.22)
Description: morph web browser
 A lightweight web browser tailored for morph, based on the Oxide browser
 engine and using the Suru UI components.

Package: morph-webapp-container
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         fonts-liberation,
         libqt5sql5-sqlite,
         libqt5webengine5,
         qml-module-qtquick2 (>= 5.5),
         qml-module-qtquick-window2 (>= 5.3),
         qml-module-ubuntu-onlineaccounts,
         qml-module-morph-web (= ${binary:Version}),
         qtdeclarative5-ubuntu-content1,
         qtdeclarative5-ubuntu-ui-toolkit-plugin (>= 1.3) | qtdeclarative5-ubuntu-ui-toolkit-plugin-gles (>= 1.3),
         qtdeclarative5-unity-action-plugin,
         morph-browser (= ${binary:Version}),
Conflicts: ubuntu-html5-container, webapp-container
Replaces: ubuntu-html5-container, webapp-container
Suggests: qml-module-ubuntu-onlineaccounts-client (>= 0.3),
Description: Morph web applications container
 A lightweight webapp container tailored for Morph, based on the QtWebEngine browser
 engine and using the Suru UI components.

Package: qml-module-ubuntu-web-compat
Architecture: any
Multi-Arch: same
Section: oldlibs
Depends: qml-module-morph-web, ${misc:Depends}
Replaces: qml-module-ubuntu-ui-extras-browser,
          qtdeclarative5-ubuntu-ui-extras-browser-plugin,
          qml-module-ubuntu-web,
          qtdeclarative5-ubuntu-web-plugin
Conflicts: qml-module-ubuntu-ui-extras-browser,
          qtdeclarative5-ubuntu-ui-extras-browser-plugin,
          qml-module-ubuntu-web,
          qtdeclarative5-ubuntu-web-plugin
Description: This provides a compat layer for Ubuntu.Web

Package: qml-module-morph-web
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-qtwebengine,
         qml-module-qtquick2 (>= 5.4),
         qml-module-qtquick-window2 (>= 5.3),
         qtdeclarative5-ubuntu-ui-toolkit-plugin (>= 1.3) | qtdeclarative5-ubuntu-ui-toolkit-plugin-gles (>= 1.3),
Breaks: qtdeclarative5-ubuntu-web-plugin (<< ${source:Version})
Replaces: qtdeclarative5-ubuntu-web-plugin (<< ${source:Version})
Description: Morph web QML module
 A standalone QML module that contains the WebView component,
 in the Morph.Web namespace.

Package: qtdeclarative5-ubuntu-web-plugin
Architecture: any
Multi-Arch: same
Section: oldlibs
Depends: qml-module-morph-web, ${misc:Depends}
Description: transitional dummy package for the Morph web QML module
 A standalone QML module that contains the WebView component,
 in the Morph.Web namespace.

Package: qml-module-morph-web-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: qtdeclarative5-ubuntu-web-plugin-doc (<< ${source:Version})
Replaces: qtdeclarative5-ubuntu-web-plugin-doc (<< ${source:Version})
Description: Morph web QML module HTML documentation
 A standalone QML module that contains the WebView component,
 in the Morph.Web namespace. This package contains the public
 HTML documentation.

Package: qtdeclarative5-ubuntu-web-plugin-doc
Section: oldlibs
Architecture: all
Multi-Arch: foreign
Depends: qml-module-morph-web-doc, ${misc:Depends}
Description: transitional dummy package for the morph web QML module HTML documentation
 A standalone QML module that contains the WebView component,
 in the morph.Web namespace. This package contains the public
 HTML documentation.

# Package: morph-browser-autopilot
# Architecture: all
# Multi-Arch: foreign
# Depends: ${misc:Depends},
#          autopilot-qt5,
#          content-hub-testability,
#          python3-autopilot,
#          python3-fixtures,
#          python3-psutil,
#          ubuntu-ui-toolkit-autopilot,
#          morph-browser (>= ${binary:Version}),
# Description: morph web browser autopilot tests
#  A lightweight web browser tailored for morph, based on the Oxide browser
#  engine and using the suru UI components. This package contains autopilot
#  tests for it.
# 
# Package: morph-webapp-container-autopilot
# Architecture: all
# Multi-Arch: foreign
# Depends: ${misc:Depends},
#          autopilot-qt5,
#          python3-autopilot,
#          python3-fixtures,
#          ubuntu-ui-toolkit-autopilot,
#          morph-webapp-container (>= ${binary:Version}),
# Description: morph web applications container autopilot tests
#  A lightweight webapp container tailored for morph, based on the Oxide browser
#  engine and using the Suru UI components. This package contains autopilot
#  tests for it.

=== src/app/morph-browser/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

BUILDHOME=/tmp/home

%:
	dh $@ --parallel --with translations

apparmor:
	aa-easyprof -m ./debian/morph-browser-apparmor.manifest --no-verify | \
	egrep -v '(# Click packages|CLICK_DIR)' | \
	sed 's/@{APP_PKGNAME}_@{APP_APPNAME}_@{APP_VERSION}/@{APP_PKGNAME}/g' | \
	sed 's#/run/shm/\.org\.chromium\.Chromium\.\*#/{dev,run}/shm/.org.chromium.Chromium.*#g' | \
	egrep -v 'deny /run/udev/data/\*\* r,' | \
	sed 's#^}$$#\n  /sys/class/ r,\n  /sys/class/input/ r,\n  /run/udev/data/** r,\n}#g' | \
	egrep -v '^\s*deny /dev/ r,\s*$$' | \
	sed 's#^\(\s*\)deny\(\s\+/{run,dev}/shm/pulse-shm\*\s\+w,\).*$$#\1owner\2#g' | \
	sed 's#^}$$#\n  /dev/dri/ r,\n  /sys/devices/pci[0-9]*/**/config r,\n}#g' | \
	sed 's#^}$$#\n  @{HOME}/@{XDG_DOWNLOAD_DIR}/** rwk,\n}#g' \
	> ./debian/usr.bin.morph-browser
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	apparmor_parser -QTK ./debian/usr.bin.morph-browser
endif

override_dh_install: apparmor
	dh_install --fail-missing

override_dh_installdeb:
	dh_apparmor --profile-name=usr.bin.morph-browser -pmorph-browser
	dh_installdeb

override_dh_translations:
	# Override dh_translations to work around http://pad.lv/1183262.
	# Unfortunately, the default build directory is not exposed
	# (see http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=601774).
	$(MAKE) -C obj-$(DEB_HOST_GNU_TYPE) morph-browser.pot

override_dh_clean:
	dh_clean
	rm -rf $(BUILDHOME)

override_dh_auto_test:
	mkdir -p $(BUILDHOME)
	HOME=$(BUILDHOME) dh_auto_test --no-parallel -- ARGS+=-VV
